#include <pic.h>
#include "delay.h"
//#include "delay.c"
#define XTAL_FREQ 8MHz
#define SW 0x03
#define clear_bit ( reg, bitNumb )
#define set_bit( reg, bitNumb )
#define test_bit( reg, bitNumb )

int i;
int k;

   __CONFIG(INTCLK & WDTDIS & PWRTDIS & MCLRDIS & UNPROTECT & BORDIS & IESODIS & FCMDIS);

// PORTC D0;SIN
// PORTC D1;SCLK
// PORTC D2;LAT
// PORTC D3;MODE
// PORTC D4;BLANK

void IoInit()
{
  OSCCON=0x70;
  TRISA = 0x08;
  TRISB = 0x08;
  TRISC = 0x00;
  PORTA=0;
  PORTB=0;
  PORTC=0;
}

void Init_DC_127()    // BLANK_Hi    
{
    PORTC=0x019;       // D6
    PORTC=0x01B;    
    PORTC=0x019;       // D5
    PORTC=0x01B;    
    PORTC=0x019;       // D4
    PORTC=0x01B;    
    PORTC=0x019;       // D3
    PORTC=0x01B;    
    PORTC=0x019;       // D2
    PORTC=0x01B;    
    PORTC=0x019;       // D1
    PORTC=0x01B;    
    PORTC=0x019;       // D0
    PORTC=0x01B;    
}

void Init_LAT_DC()    // BLANK Hi
{
    PORTC=0x018;    
    PORTC=0x01C;    
    PORTC=0x018;    
}

void Init_OUT_ALL_ON() // BLANK_Hi    
{
    PORTC=0x011;       // OUT15
    PORTC=0x013;    
    PORTC=0x011;       // OUT14
    PORTC=0x013;    
    PORTC=0x011;       // OUT13
    PORTC=0x013;    
    PORTC=0x011;       // OUT12
    PORTC=0x013;    
    PORTC=0x011;       // OUT11
    PORTC=0x013;    
    PORTC=0x011;       // OUT10
    PORTC=0x013;    
    PORTC=0x011;       // OUT9
    PORTC=0x013;    
    PORTC=0x011;       // OUT8
    PORTC=0x013;    
    PORTC=0x011;       // OUT7
    PORTC=0x013;    
    PORTC=0x011;       // OUT6
    PORTC=0x013;    
    PORTC=0x011;       // OUT5
    PORTC=0x013;    
    PORTC=0x011;       // OUT4
    PORTC=0x013;    
    PORTC=0x011;       // OUT3
    PORTC=0x013;    
    PORTC=0x011;       // OUT2
    PORTC=0x013;    
    PORTC=0x011;       // OUT1
    PORTC=0x013;    
    PORTC=0x011;       // OUT0
    PORTC=0x013;    
}

void Init_LAT_OUT() // BLANK Hi
{
    PORTC=0x010;    
    PORTC=0x014;    
    PORTC=0x010;     
}

void LED_ON()    // By BLANK Lo
{
    PORTC=0x00;    // BLANK Lo
}

void LED_OFF()    // By BLANK Hi
{
    PORTC=0x010;    // BLANK Hi
}

void LAT_DC()    // BLANK Lo
{
    PORTC=0x08;    
    PORTC=0x0C;    
    PORTC=0x08;    
}

void LAT_ON_OFF() // BLANK Lo
{
    PORTC=0x00;    
    PORTC=0x04;    
    PORTC=0x00;    
}

void DC_127_Lo()    // BLANK_Lo    
{
    PORTC=0x09;     // D6 
    PORTC=0x0B;    
    PORTC=0x09;     // D5
    PORTC=0x0B;    
    PORTC=0x09;     // D4
    PORTC=0x0B;    
    PORTC=0x09;     // D3
    PORTC=0x0B;    
    PORTC=0x09;     // D2 
    PORTC=0x0B;    
    PORTC=0x09;     // D1
    PORTC=0x0B;    
    PORTC=0x09;     // D0
    PORTC=0x0B;    
}

void DC_64_Lo()    // BLANK_Lo    
{
    PORTC=0x09;       // D6
    PORTC=0x0B;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}

void DC_32_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x09;       // D5
    PORTC=0x0B;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}

void DC_16_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x09;       // D4
    PORTC=0x0B;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}

void DC_8_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x09;       // D3
    PORTC=0x0B;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}

void DC_4_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x09;       // D2
    PORTC=0x0B;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}

void DC_2_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x09;       // D1
    PORTC=0x0B;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}

void DC_1_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x09;       // D0
    PORTC=0x0B;    
}

void DC_0_Lo()    // BLANK_Lo    
{
    PORTC=0x08;       // D6
    PORTC=0x0A;    
    PORTC=0x08;       // D5
    PORTC=0x0A;    
    PORTC=0x08;       // D4
    PORTC=0x0A;    
    PORTC=0x08;       // D3
    PORTC=0x0A;    
    PORTC=0x08;       // D2
    PORTC=0x0A;    
    PORTC=0x08;       // D1
    PORTC=0x0A;    
    PORTC=0x08;       // D0
    PORTC=0x0A;    
}


void OUT_ALL_ON()    // BLANK_Lo    
{
    PORTC=0x01;       // OUT15
    PORTC=0x03;    
    PORTC=0x01;       // OUT14
    PORTC=0x03;    
    PORTC=0x01;       // OUT13
    PORTC=0x03;    
    PORTC=0x01;       // OUT12
    PORTC=0x03;    
    PORTC=0x01;       // OUT11
    PORTC=0x03;    
    PORTC=0x01;       // OUT10
    PORTC=0x03;    
    PORTC=0x01;       // OUT9
    PORTC=0x03;    
    PORTC=0x01;       // OUT8
    PORTC=0x03;    
    PORTC=0x01;       // OUT7
    PORTC=0x03;    
    PORTC=0x01;       // OUT6
    PORTC=0x03;    
    PORTC=0x01;       // OUT5
    PORTC=0x03;    
    PORTC=0x01;       // OUT4
    PORTC=0x03;    
    PORTC=0x01;       // OUT3
    PORTC=0x03;    
    PORTC=0x01;       // OUT2
    PORTC=0x03;    
    PORTC=0x01;       // OUT1
    PORTC=0x03;    
    PORTC=0x01;       // OUT0
    PORTC=0x03;    
}

void OUT_ON_Even()    // BLANK_Lo    
{
    PORTC=0x00;       // OUT15
    PORTC=0x02;    
    PORTC=0x01;       // OUT14
    PORTC=0x03;    
    PORTC=0x00;       // OUT13
    PORTC=0x02;    
    PORTC=0x01;       // OUT12
    PORTC=0x03;    
    PORTC=0x00;       // OUT11
    PORTC=0x02;    
    PORTC=0x01;       // OUT10
    PORTC=0x03;    
    PORTC=0x00;       // OUT9
    PORTC=0x02;    
    PORTC=0x01;       // OUT8
    PORTC=0x03;    
    PORTC=0x00;       // OUT7
    PORTC=0x02;    
    PORTC=0x01;       // OUT6
    PORTC=0x03;    
    PORTC=0x00;       // OUT5
    PORTC=0x02;    
    PORTC=0x01;       // OUT4
    PORTC=0x03;    
    PORTC=0x00;       // OUT3
    PORTC=0x02;    
    PORTC=0x01;       // OUT2
    PORTC=0x03;    
    PORTC=0x00;       // OUT1
    PORTC=0x02;    
    PORTC=0x01;       // OUT0
    PORTC=0x03;    

}

void OUT_ON_ODD()    // BLANK_Lo    
{
    PORTC=0x01;       // OUT15
    PORTC=0x03;    
    PORTC=0x00;       // OUT14
    PORTC=0x02;    
    PORTC=0x01;       // OUT13
    PORTC=0x03;    
    PORTC=0x00;       // OUT12
    PORTC=0x02;    
    PORTC=0x01;       // OUT11
    PORTC=0x03;    
    PORTC=0x00;       // OUT10
    PORTC=0x02;    
    PORTC=0x01;       // OUT9
    PORTC=0x03;    
    PORTC=0x00;       // OUT8
    PORTC=0x02;    
    PORTC=0x01;       // OUT7
    PORTC=0x03;    
    PORTC=0x00;       // OUT6
    PORTC=0x02;    
    PORTC=0x01;       // OUT5
    PORTC=0x03;    
    PORTC=0x00;       // OUT4
    PORTC=0x02;    
    PORTC=0x01;       // OUT3
    PORTC=0x03;    
    PORTC=0x00;       // OUT2
    PORTC=0x02;    
    PORTC=0x01;       // OUT1
    PORTC=0x03;    
    PORTC=0x00;       // OUT0
    PORTC=0x02;    

}

void OUT_ALL_OFF()    // BLANK_Lo    
{
    PORTC=0x00;       // OUT15
    PORTC=0x02;    
    PORTC=0x00;       // OUT14
    PORTC=0x02;    
    PORTC=0x00;       // OUT13
    PORTC=0x02;    
    PORTC=0x00;       // OUT12
    PORTC=0x02;    
    PORTC=0x00;       // OUT11
    PORTC=0x02;    
    PORTC=0x00;       // OUT10
    PORTC=0x02;    
    PORTC=0x00;       // OUT9
    PORTC=0x02;    
    PORTC=0x00;       // OUT8
    PORTC=0x02;    
    PORTC=0x00;       // OUT7
    PORTC=0x02;    
    PORTC=0x00;       // OUT6
    PORTC=0x02;    
    PORTC=0x00;       // OUT5
    PORTC=0x02;    
    PORTC=0x00;       // OUT4
    PORTC=0x02;    
    PORTC=0x00;       // OUT3
    PORTC=0x02;    
    PORTC=0x00;       // OUT2
    PORTC=0x02;    
    PORTC=0x00;       // OUT1
    PORTC=0x02;    
    PORTC=0x00;       // OUT0
    PORTC=0x02;    

}



void main(void)   // START MAIN
{
 
  IoInit();
 
    
  for (k=0; k<32; k++){
   Init_DC_127();         // All Hi of 7bit DC  32 = 16ch  x 2pcs 
   }  

   Init_LAT_DC()           // BLANK Hi


 for (k=0; k<2; k++){
   Init_OUT_ALL_ON();     // BLANK_Hi   16ch x 2pcs 
   }  

  Init_LAT_ON_OFF();      // BLANK Hi
   

 while(1){
  //  LED ON & OFF by BLANK
   LED_ON();      // BLANK Lo

   DelayS(1);     // 1sec  

   LED_OFF();      // BLANK Hi

   DelayS(1);     // 1sec  

   LED_ON();      // BLANK Lo

   DelayS(1);     // 1sec  
    
   for (k=0; k<16; k++){
       DC_64_Lo();     // BLANK_Lo   16ch x #1 
   }  

   for (k=0; k<16; k++){
       DC_8_Lo();     // BLANK_Lo   16ch x #2 
   }  

   LAT_DC();    // LATCH at BLANK Lo


   DelayS(2);     // 2sec  
 
   for (k=0; k<16; k++){
       DC_8_Lo();     // BLANK_Lo   16ch x #1 
   }  

   for (k=0; k<16; k++){
        DC_64_Lo();     // BLANK_Lo   16ch x #2 
   }  

   LAT_DC();    // LATCH at BLANK Lo


   DelayS(2);     // 2sec  


   for (k=0; k<16; k++){
       DC_8_Lo();     // BLANK_Lo   16ch x #1 
   }  

   for (k=0; k<16; k++){
       DC_64_Lo();     // BLANK_Lo   16ch x #2 
   }  

   LAT_DC();    // LATCH at BLANK Lo

   DelayS(2);     // 2sec  

  for (k=0; k<32; k++){
       DC_127_Lo();     // BLANK_Lo   16ch x 2pcs 
   }  

   LAT_DC();    // LATCH at BLANK Lo

   DelayS(2);     // 2sec  

  for (k=0; k<2; k++){
   OUT_ON_Even();    // BLANK_Lo16ch x 2pcs 
   }  
   
  LAT_ON_OFF(); // BLANK Lo

   DelayS(2);     // 2sec 

  for (k=0; k<2; k++){
   OUT_ON_ODD();    // BLANK_Lo16ch x 2pcs 
   }  

  LAT_ON_OFF(); // BLANK Lo

   DelayS(2);     // 2sec 


 for (k=0; k<2; k++){
   OUT_ALL_ON()    // BLANK_Lo  16ch x 2pcs 
   }  

   LAT_ON_OFF(); // BLANK Lo

   DelayS(2);     // 2sec 

  }


